<div class="input-container">

  <ng-container [ngSwitch]="controlType">
    <div *ngSwitchCase="'TEXT'" [formGroup]="parentForm" class="input-container">
      <div class="p-grid">
        <div class="p-col-3 right-align-container">
          <label class="label" for="controlName">{{ labelValue }}</label>
        </div>
        <div class="p-col-9 left-align-container">
          <input [formControlName]="controlName" class="input" id="controlName" pInputText type="text">
        </div>

      </div>
    </div>
    <div *ngSwitchCase="'TEXT_PASSWORD'" [formGroup]="parentForm" class="input-container">
      <div class="p-grid">
        <div class="p-col-3 right-align-container">
          <label class="label" for="controlName">{{ labelValue }}</label>
        </div>
        <div class="p-col-9 left-align-container">
          <input [formControlName]="controlName" class="input" id="controlName" pInputText type="password">
        </div>

      </div>
    </div>
    <div *ngSwitchCase="'DROPDOWN'" [formGroup]="parentForm" class="input-container">
      <div class="p-grid">
        <div class="p-col-3 right-align-container">
          <label class="label" for="controlName">{{ labelValue }}</label>
        </div>
        <div class="p-col-9 left-align-container">
          <p-dropdown [formControlName]="controlName" [options]="dropdownValues" class="input" optionLabel="name"
                      placeholder="choose"></p-dropdown>
        </div>

      </div>
    </div>
    <div *ngSwitchCase="'BOOLEAN'" [formGroup]="parentForm" class="input-container">
      <div class="p-grid">
        <div class="p-col-3 right-align-container">
          <label class="label" for="controlName">{{ labelValue }}</label>
        </div>
        <div class="p-col-9 left-align-container">
          <p-inputSwitch [formControlName]="controlName"></p-inputSwitch>
        </div>
      </div>
    </div>
    <div *ngSwitchCase="'TEXT_AREA'" [formGroup]="parentForm" class="input-container">
      <div class="p-grid">
        <div class="p-col-3 right-align-container">
          <label class="label" for="controlName">{{ labelValue }}</label>
        </div>
        <div class="p-col-9 left-align-container">
          <textarea [formControlName]="controlName" pInputTextarea style="width: 100%; height: 200px;"></textarea>
        </div>
      </div>
    </div>
    <div *ngSwitchCase="'PRICE'" [formGroup]="parentForm" class="input-container">
      <div class="p-grid">
        <div class="p-col-3 right-align-container">
          <label class="label" for="controlName">{{ labelValue }}</label>
        </div>
        <div class="p-col-9 left-align-container">
          <p-inputNumber
            [formControlName]="controlName"
            [min]="0"
            [showButtons]="true"
            [step]="1"
            buttonLayout="horizontal"
            decrementButtonClass="p-button-danger"
            decrementButtonIcon="pi pi-minus"
            incrementButtonClass="p-button-success"
            incrementButtonIcon="pi pi-plus"
            inputId="horizontal"
            locale="en-US"
            spinnerMode="horizontal"
          >
          </p-inputNumber>
        </div>
      </div>
    </div>
    <div *ngSwitchCase="'MIN_MAX_PRICE'" [formGroup]="parentForm" class="input-container">
      <div class="p-grid">
        <div class="p-col-3 right-align-container">
          <label class="label" for="controlName">{{ labelValue }}</label>
        </div>
        <div class="p-col-9 left-align-container">
          <p-inputNumber
            [formControlName]="controlName"
            [min]="minPrice + 1"
            [showButtons]="true"
            [step]="1"
            buttonLayout="horizontal"
            decrementButtonClass="p-button-danger"
            decrementButtonIcon="pi pi-minus"
            incrementButtonClass="p-button-success"
            incrementButtonIcon="pi pi-plus"
            inputId="horizontal"
            locale="en-US"
            spinnerMode="horizontal"
          >
          </p-inputNumber>
        </div>
      </div>
    </div>
    <div *ngSwitchCase="'EDIT_TEXT'" [formGroup]="parentForm" class="input-container">
      <div class="p-grid">
        <div class="p-col-1 right-align-container">
          <label class="label" for="controlName">{{ labelValue }}</label>
        </div>
        <div class="p-col-11"></div>
        <div class="p-col-12 left-align-container">
          <p-editor [formControlName]="controlName" [style]="{'height':'200px'}"
          >
            <p-header>
                        <span class="ql-formats">
                          <button aria-label="Bold" class="ql-bold"></button>
                          <button aria-label="Italic" class="ql-italic"></button>
                          <button aria-label="Underline" class="ql-underline"></button>
                          <button aria-label="Strike" class="ql-strike"></button>
                        </span>
            </p-header>
          </p-editor>
        </div>
      </div>
    </div>
    <div *ngSwitchCase="'OPTION'" [formGroup]="parentForm" class="input-container">
      <div class="p-grid">
        <div class="p-col-3 right-align-container">
          <label class="label" for="controlName">{{ labelValue }}</label>
        </div>
        <div class="p-col-9 left-align-container">
          <!--              <textarea pInputTextarea [formControlName]="controlName" style="width: 100%; height: 200px;"></textarea>-->
          <p-selectButton
            [formControlName]="controlName"
            [options]="optionsToSelect"
            optionLabel="name"
          ></p-selectButton>
        </div>
      </div>
    </div>
  </ng-container>


  <div *ngIf="formControl?.errors && (formControl?.touched || formControl?.dirty)">
    <div *ngFor="let errorKey of errorKeys">
      <div *ngIf="formControl.hasError(errorKey) && (parentForm?.touched || parentForm?.dirty)"
           class="cross-validation-error-message alert alert-danger input-container">
        <div class="p-grid">
          <div class="p-col-3"></div>
          <div class="p-col-9 left-align-container alert-info">
            <ng-container [ngSwitch]="errorKey">
              <div *ngSwitchCase="'required'">
                This element is required
              </div>
              <div *ngSwitchCase="'passwordIsNotEquals'">
                Passwords must be equals!
              </div>
              <div *ngSwitchCase="'minlength'">
                Min length : {{formControl.errors.minlength.requiredLength}}
              </div>
              <div *ngSwitchCase="'maxlength'">
                Max length : {{formControl.errors.maxlength.requiredLength}}
              </div>
              <div *ngSwitchCase="'email'">
                Wrong email format
              </div>
              <div *ngSwitchCase="'emailIsTaken'">
                emailIsTaken
              </div>
              <div *ngSwitchCase="'loginIsTaken'">
                This login is already taken!
              </div>
              <div *ngSwitchCase="'userNameIsTaken'">
                This user name is already taken!
              </div>
              <div *ngSwitchCase="'secretKeyIsInCorrect'">
                Incorrect key!
              </div>
            </ng-container>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
